Project Chrono: chrono::vehicle::TrackShoeDoublePin Class Reference

Public Member Functions | List of all members
chrono::vehicle::TrackShoeDoublePin Class Reference
VEHICLE module » Tracked vehicles » Track-shoe subsystem

## Description

Double-pin track shoe with central guide constructed with data from file (JSON format).

`#include <TrackShoeDoublePin.h>`

Inheritance diagram for chrono::vehicle::TrackShoeDoublePin:
[legend]
Collaboration diagram for chrono::vehicle::TrackShoeDoublePin:
[legend]

## Public Member Functions
| TrackShoeDoublePin (const std::string &filename)
| TrackShoeDoublePin (const rapidjson::Document &d)
virtual GuidePinType | GetType () const final override
| Return the type of track shoe (guiding pin).
virtual double | GetHeight () const override
| Return the height of the track shoe.
virtual double | GetShoeMass () const override
| Return the mass of the shoe body.
virtual const ChVector3d & | GetShoeInertia () const override
| Return the moments of inertia of the shoe body.
virtual double | GetShoeLength () const override
| Return shoe length (distance between pins).
virtual double | GetShoeWidth () const override
| Return shoe width (separation between connectors).
virtual double | GetConnectorMass () const override
| Return the mass of a connector body.
virtual const ChVector3d & | GetConnectorInertia () const override
| Return the moments of inertia of a connector body.
virtual double | GetConnectorLength () const override
| Return the length of a connector body.
virtual double | GetConnectorRadius () const override
| Return the radius of a connector body.
virtual double | GetConnectorWidth () const override
| Return the width of a connector body (visualization only).
virtual ChVector3d | GetLateralContactPoint () const override
| Return the location of the guiding pin center, expressed in the shoe reference frame.
virtual ChVehicleGeometry | GetGroundContactGeometry () const override
| Return contact geometry and material for interaction with terrain.
Public Member Functions inherited from chrono::vehicle::ChTrackShoeDoublePin
| ChTrackShoeDoublePin (const std::string &name, DoublePinTrackShoeType topology)
virtual std::string | GetTemplateName () const override
| Get the name of the vehicle subsystem template.
virtual double | GetPitch () const override
| Return the pitch length of the track shoe.
virtual ChVector3d | GetTension () const override
| Get track tension at this track shoe.
virtual void | Initialize (std::shared_ptr< ChBodyAuxRef > chassis, const ChVector3d &location, const ChQuaternion<> &rotation) override
| Initialize this track shoe subsystem.
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the track shoe subsystem.
virtual void | RemoveVisualizationAssets () override final
| Remove visualization assets for the track shoe subsystem.
Public Member Functions inherited from chrono::vehicle::ChTrackShoeSegmented
std::shared_ptr< ChContactMaterial > | GetSprocketContactMaterial () const
| Get the contact material for the track shoe part interacting with the sprocket.
Public Member Functions inherited from chrono::vehicle::ChTrackShoe
size_t | GetIndex () const
| Get the index of this track shoe within its containing track assembly.
std::shared_ptr< ChBody > | GetShoeBody () const
| Get the shoe body.
void | EnableCollision (bool val)
| Turn on/off collision flag for the shoe body.
void | SetIndex (size_t index)
| Set the index of this track shoe within its containing track assembly.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Protected Member Functions inherited from chrono::vehicle::ChTrackShoeDoublePin
virtual void | InitializeInertiaProperties () override
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties () override
| Update subsystem inertia properties.
void | Initialize (std::shared_ptr< ChBodyAuxRef > chassis, const ChVector3d &loc_shoe, const ChQuaternion<> &rot_shoe, const ChVector3d &loc_connector_L, const ChVector3d &loc_connector_R, const ChQuaternion<> &rot_connector)
| Initialize this two-connector double-pin track shoe system.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const override
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const override
| Output data for this subsystem's component list to the specified database.
Protected Member Functions inherited from chrono::vehicle::ChTrackShoeSegmented
| ChTrackShoeSegmented (const std::string &name)
Protected Member Functions inherited from chrono::vehicle::ChTrackShoe
| ChTrackShoe (const std::string &name)
| Construct a track shoe subsystem with given name.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).
Protected Attributes inherited from chrono::vehicle::ChTrackShoeDoublePin
DoublePinTrackShoeType | m_topology
| topology of the track shoe (one or two connectors)
std::shared_ptr< ChBody > | m_connector_L
| left connector body
std::shared_ptr< ChBody > | m_connector_R
| right connector body
std::shared_ptr< ChVehicleJoint > | m_joint_L
| shoe - left connector joint
std::shared_ptr< ChVehicleJoint > | m_joint_R
| shoe - right connector joint
std::shared_ptr< ChLinkRSDA > | m_rsda_L
| optional RSDA on left revolute
std::shared_ptr< ChLinkRSDA > | m_rsda_R
| optional RSDA on right revolute
std::shared_ptr< ChVehicleJoint > | m_connection_joint_L
| connection to neighboring track shoe
std::shared_ptr< ChVehicleJoint > | m_connection_joint_R
| connection to neighboring track shoe
std::shared_ptr< ChLinkRSDA > | m_connection_rsda_L
| optional RSDA on connection
std::shared_ptr< ChLinkRSDA > | m_connection_rsda_R
| optional RSDA on connection
Protected Attributes inherited from chrono::vehicle::ChTrackShoeSegmented
ChVehicleGeometry | m_geometry
| collection of visualization and collision shapes
ChContactMaterialData | m_shoe_sprk_minfo
| data for contact material for shoe shape contacting sprocket
Protected Attributes inherited from chrono::vehicle::ChTrackShoe
size_t | m_index
| index of this track shoe within its containing track assembly
std::shared_ptr< ChBody > | m_shoe
| handle to the shoe body
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Member Function Documentation

## ◆ GetConnectorInertia()

virtual const ChVector3d & chrono::vehicle::TrackShoeDoublePin::GetConnectorInertia | ( |  | ) | const
| inlineoverridevirtual

Return the moments of inertia of a connector body.

Implements chrono::vehicle::ChTrackShoeDoublePin.

## ◆ GetConnectorLength()

virtual double chrono::vehicle::TrackShoeDoublePin::GetConnectorLength | ( |  | ) | const
| inlineoverridevirtual

Return the length of a connector body.

Implements chrono::vehicle::ChTrackShoeDoublePin.

## ◆ GetConnectorMass()

virtual double chrono::vehicle::TrackShoeDoublePin::GetConnectorMass | ( |  | ) | const
| inlineoverridevirtual

Return the mass of a connector body.

Implements chrono::vehicle::ChTrackShoeDoublePin.

## ◆ GetConnectorRadius()

virtual double chrono::vehicle::TrackShoeDoublePin::GetConnectorRadius | ( |  | ) | const
| inlineoverridevirtual

Return the radius of a connector body.

Implements chrono::vehicle::ChTrackShoeDoublePin.

## ◆ GetConnectorWidth()

virtual double chrono::vehicle::TrackShoeDoublePin::GetConnectorWidth | ( |  | ) | const
| inlineoverridevirtual

Return the width of a connector body (visualization only).

Implements chrono::vehicle::ChTrackShoeDoublePin.

## ◆ GetGroundContactGeometry()

virtual ChVehicleGeometry chrono::vehicle::TrackShoeDoublePin::GetGroundContactGeometry | ( |  | ) | const
| inlineoverridevirtual

Return contact geometry and material for interaction with terrain.

Reimplemented from chrono::vehicle::ChTrackShoe.

## ◆ GetHeight()

virtual double chrono::vehicle::TrackShoeDoublePin::GetHeight | ( |  | ) | const
| inlineoverridevirtual

Return the height of the track shoe.

Implements chrono::vehicle::ChTrackShoe.

## ◆ GetLateralContactPoint()

virtual ChVector3d chrono::vehicle::TrackShoeDoublePin::GetLateralContactPoint | ( |  | ) | const
| inlineoverridevirtual

Return the location of the guiding pin center, expressed in the shoe reference frame.

Implements chrono::vehicle::ChTrackShoe.

## ◆ GetShoeInertia()

virtual const ChVector3d & chrono::vehicle::TrackShoeDoublePin::GetShoeInertia | ( |  | ) | const
| inlineoverridevirtual

Return the moments of inertia of the shoe body.

Implements chrono::vehicle::ChTrackShoeDoublePin.

## ◆ GetShoeLength()

virtual double chrono::vehicle::TrackShoeDoublePin::GetShoeLength | ( |  | ) | const
| inlineoverridevirtual

Return shoe length (distance between pins).

Implements chrono::vehicle::ChTrackShoeDoublePin.

## ◆ GetShoeMass()

virtual double chrono::vehicle::TrackShoeDoublePin::GetShoeMass | ( |  | ) | const
| inlineoverridevirtual

Return the mass of the shoe body.

Implements chrono::vehicle::ChTrackShoeDoublePin.

## ◆ GetShoeWidth()

virtual double chrono::vehicle::TrackShoeDoublePin::GetShoeWidth | ( |  | ) | const
| inlineoverridevirtual

Return shoe width (separation between connectors).

Implements chrono::vehicle::ChTrackShoeDoublePin.

## ◆ GetType()

virtual GuidePinType chrono::vehicle::TrackShoeDoublePin::GetType | ( |  | ) | const
| inlinefinaloverridevirtual

Return the type of track shoe (guiding pin).

A derived class must specify the type of track shoe (which must be consistent with the idler and road wheels in the containing track assembly.

Implements chrono::vehicle::ChTrackShoe.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/track_shoe/TrackShoeDoublePin.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/tracked_vehicle/track_shoe/TrackShoeDoublePin.cpp